<?php

if( !$feedURL ) { $feedURL = $_GET ? $_GET['feedURL'] : $HTTP_GET_VARS['feedURL']; $fix091 = $_GET ? $_GET['fix091'] : $HTTP_GET_VARS['fix091']; }
if( $feedURL && preg_match("/^https?:\/\/.+$/",$feedURL) && ( $feedRef = @fopen($feedURL,'rb') ) ) {
	$contents = ''; while( !feof( $feedRef ) ) { $contents .= fread( $feedRef, 8192 ); }
	if( $fix091 ) { $contents = preg_replace("/(<rss\s([^>]*\s)?)version\s*=\s*['\"]\s*0?.91\s*['\"]/i","$1".'version="allowHTML91"',$contents); }
	$contents = preg_replace("/(<rss|<atom|<opml|<outlineDocument)/",'<'.'?xml-stylesheet type="text/css" href="empty.css" ?'.">$1",preg_replace("/<\?xml-stylesheet[^?]*\?(>)/i",'',preg_replace("/<(\/?)link/i","<$1fixlink",preg_replace("/<(\/?)image/i","<$1fiximage",preg_replace("/<(\/?)rss/i","<$1rssSpoof",preg_replace("/<(\/?)feed/i","<$1atomSpoof",$contents))))));
	header('Content-Type: text/xml');
	header('Content-Length: '.strlen($contents)); //IE doesn't work without it
	print $contents;
} else {
	header('Content-Type: text/xml');
	header('Content-Length: 562');
?><<?php ?>?xml version="1.0" encoding="ISO-8859-1" ?<?php ?>>
<<?php ?>?xml-stylesheet type="text/css" href="empty.css" ?<?php ?>>
<rssSpoof version="0.91">
  <channel>
    <title>Please enter a valid feed URL</title>
    <link>http://www.google.com/search?q=rss</link> 
    <description></description>
    <language></language>
    <item>
      <title>Invalid feed URL detected</title>
      <link>http://www.google.com/search?q=rss</link>
      <description>RSS newsfeeds are served with a URL beginning with http:// or https://</description>
    </item>
  </channel>
</rssSpoof><?php
}

/********************************************************************
                            Documentation
*********************************************************************

Algorithm:

Get the two variables that were passed: feedURL and fix091
If feedURL does not begin with http:// or https:// assume they are trying to trick it into running scripts on the server.
If they are not trying to trick it, try to open the URL specified by feedURL.
If the URL does not exist, assume it is not a valid feed URL.
If they are trying to trick it, or if it is an invalid feed URL, then:
  Send the header "Content-Type: text/xml" (without quotes)
  Send the header "Content-Length: 562" (without quotes)
  Print out the error feed.
  Exit.
Otherwise read the contents of the feed document, and begin working around various feed and browser bugs:
  If fix091 was specified (typically with value '1', although it doesn't matter), replace the version="0.91" attribute
    on the <rss ...> tag with version="allowHTML91" - specifically, replace any occurrence of:
      /(<rss\s([^>]*\s)?)version\s*=\s*['"]0.91['"]/i with %FIRST_CAPTURE%version="allowHTML91"
  Remove any XML stylesheet links that are already in the feed - eg. <?xml-stylesheet type="text/css" href="foo.css" ?>
  Add a link to an empty XML stylesheet:
    <?xml-stylesheet type="text/css" href="empty.css" ?>
    before the first occurance of one of these tags:
    <rss <atom <opml <outlineDocument
  Replace all occurrences of <link ...> and </link> with <fixlink ...> and </fixlink> respectively.
  Replace all occurrences of <image ...> and </image> with <fiximage ...> and </fiximage> respectively.
  Replace all occurrences of <rss ...> and </rss> with <rssSpoof ...> and </rssSpoof> respectively.
  Replace all occurrences of <feed ...> and </feed> with <atomSpoof ...> and </atomSpoof> respectively.
  Send the header "Content-Type: text/xml" (without quotes)
  Send the header "Content-Length: %LENGTH_OF_NEW_CONTENTS%" (without quotes)
  Print out the new contents.
  Exit.

Error feed (indents and [windows] linebreaks are important and must be preserved exactly):

<?xml version="1.0" encoding="ISO-8859-1" ?>
<?xml-stylesheet type="text/css" href="empty.css" ?>
<rssSpoof version="0.91">
  <channel>
    <title>Please enter a valid feed URL</title>
    <link>http://www.google.com/search?q=rss</link> 
    <description></description>
    <language></language>
    <item>
      <title>Invalid feed URL detected</title>
      <link>http://www.google.com/search?q=rss</link>
      <description>RSS newsfeeds are served with a URL beginning with http:// or https://</description>
    </item>
  </channel>
</rssSpoof>
_______________________________________________________________________________________________________*/

?>